/*
Released under the zlib/libpng License 
Copyright (c) 2005 Mirko Ellinger / Johan B Klassen 

This software is provided 'as-is', without any express or implied warranty. In no event will
the authors be held liable for any damages arising from the use of this software. 

Permission is granted to anyone to use this software for any purpose,
including commercial applications, and to alter it and redistribute it freely,
subject to the following restrictions: 

1. The origin of this software must not be misrepresented; you must not claim that you wrote the original software.
 If you use this software in a product, an acknowledgment in the product documentation
 would be appreciated but is not required. 

2. Altered source versions must be plainly marked as such, and must not be misrepresented
 as being the original software. 

3. This notice may not be removed or altered from any source distribution. 

*/


/* Disable the following line to test your library.*/
#define PURELIBRARY
#define VC6
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <float.h>
#include <time.h>
#include <stdarg.h>
#ifdef VC6
  char _fltused;
  #define M_E 2.7182818284590452353602874713527
  #define M_PI 3.1415926535897932384626433832795
  #define M_LN10 2.3025850929940456840179914546844
#endif
extern char* PB_StringBase;

extern char* _stdcall PB_F64_Str(double* d)
{
   int p=6;
   char* ResultString = PB_StringBase;
   char format[]="                                                  "; 
   sprintf(format,"%s%s%d%s","%"," .", p  ,"f");
   sprintf(ResultString, format, *d);
   PB_StringBase+=strlen(ResultString);
   *PB_StringBase=0;
   return ResultString;
}
extern void _stdcall PB_F64_Val(double* d, char* s)
{
  *d = atof(s);
}

extern char* _stdcall PB_F64_Str2(double* d, int p)
{
  int pr=abs(p);
  char* ResultString = PB_StringBase;
  char format[]="                         ";
  if (pr>16)
     pr=16;
   sprintf(format,"%s%s%d%s","%"," .", pr  ,"f");
   sprintf(ResultString, format, *d);
   PB_StringBase+=strlen(ResultString);
   *PB_StringBase=0;
  return ResultString;
}
extern char* _stdcall PB_F64_Str3(double* d, int p, int e)
{
  int pr=abs(p);
  char* ResultString = PB_StringBase;
  char format[]="                         ";
  if (pr>16)
     pr=16;
  if(e==0)
    sprintf(format,"%s%s%d%s","%"," .", pr  ,"f");
  else if(e==1)
      sprintf(format,"%s%s%d%s","%"," .", pr  ,"e");
  else
      sprintf(format,"%s%s%d%s","%"," .", pr  ,"g");
   sprintf(ResultString, format, *d);
   PB_StringBase+=strlen(ResultString);
   *PB_StringBase=0;
  return ResultString;
}
extern int _stdcall PB_F64_Version(void)
{
	return 0x0000005F;
}
extern double* _stdcall PB_F64_PI(double* d)
{
  *d = M_PI;
  return d;
}
extern double* _stdcall PB_F64_E(double* d)
{
  *d = M_E;
  return d;
}
extern void _stdcall PB_F64_Copy(double* d1, double* d2)
{
  *d1 = *d2;
}
extern void _stdcall PB_F64_Swap(double* d1, double* d2)
{
  double h;
  h = *d1;
  *d1 = *d2;
  *d2 = h;
}
extern int _stdcall PB_F64_Cmp(double* d1, double* d2)
{
  if(*d1 > *d2)
	return 1;
  else
	if(*d1 < *d2)
      return -1;
  return 0;
}
extern int _stdcall PB_F64_Equ(double* d1, double* d2)
{
  if(*d1 == *d2)
    return 1;
  return 0;
}
extern int _stdcall PB_F64_IsInt(double* d1)
{
	double n;
	n=fabs(*d1);
	if ((n-floor(n))==0)
		return 1;
  	else
	  return 0;
}
extern int _stdcall PB_F64_IsInfinite(double* d1)
{
	int n;
	n=_fpclass(*d1);
	if (n==_FPCLASS_PINF)
		return 1;
	else
	if (n==_FPCLASS_NINF)
		return -1;
	else
	return 0;
}
extern int _stdcall PB_F64_IsInfinite2(double* d1, double* d2)
{
	int n;
	*d2=0;
	n=_fpclass(*d1);
	if (n==_FPCLASS_PINF)
		{*d2=1;
		return 1;}
	else
	if (n==_FPCLASS_NINF)
		{*d2=-1;
		return -1;}
	else
	return 0;
}
extern int _stdcall PB_F64_IsNaN(double* d1)
{
	int n;
	n=_isnan(*d1);
	return n;
}
extern int _stdcall PB_F64_IsNaN2(double* d1, double* d2)
{
	int n;
	n=_isnan(*d1);
	*d2=(double) n;
	return n;
}
extern int _stdcall PB_F64_IsOdd(double* d1)
{
	double n;
	int d=(int) *d1;
	int m=0;
	n=fabs(*d1);
	if ((n-floor(n))==0)
		if ((d%2)!=0)
			m=1;
	return m;
}
extern int _stdcall PB_F64_IsOdd2(double* d1,double* d2)
{
	double n;
	int d=(int) *d1;
	int m=0;
	n=fabs(*d1);
	if ((n-floor(n))==0)
		if ((d%2)!=0)
			m=1;
	*d2=(double) m;
	return m;
}
extern int _stdcall PB_F64_IsEven(double* d1)
{
	double n;
	int m=0;
	int d=(int) *d1;
	n=fabs(*d1);
	if ((n-floor(n))==0)
		if ((d%2)==0)
			m=1;
	return m;
}
extern int _stdcall PB_F64_IsEven2(double* d1,double* d2)
{
	double n;
	int d=(int) *d1;
	int m=0;
	n=fabs(*d1);
	if ((n-floor(n))==0)
		if ((d%2)==0)
			m=1;
	*d2=(double) m;
	return m;
}

extern void _stdcall PB_F64_Float(double* d, float f)
{
  *d = f;
}
extern float _stdcall PB_F64_toFloat(double* d)
{
  return (float)*d;
}
extern double* _stdcall PB_F64_Int(double* d1, int n)
{
	*d1=(double) n;
	return d1;
}
extern int _stdcall PB_F64_toInt(double* d)
{
  return (int) *d;
}
extern double* _stdcall PB_F64_Frac(double* d1)
{
	double n;
	n=fabs(*d1);
	n=n-floor(n);
	if (*d1<0.0)
		*d1=(0.0-n);
	else
		*d1=n;
	return d1;
}
extern double* _stdcall PB_F64_Frac2(double* d1, double* d2)
{
	double n;
	n=fabs(*d1);
	*d2=n-floor(n);
	if (*d1<0.0)
		*d2=(0.0-(*d2));
	return d2;
}

extern double* _stdcall PB_F64_Integer(double* d1)
{
	double n;
	n=floor(fabs(*d1));
	if (*d1<0)
		*d1=0.0-n;
	else
		*d1=n;
	return d1;
}
extern double* _stdcall PB_F64_Integer2(double* d1, double* d2)
{
	double n;
	n=floor(fabs(*d1));
	if (*d1<0)
		*d2=0.0-n;
	else
		*d2=n;
	return d2;
}
extern double* _stdcall PB_F64_Ceil(double* d1)
{
	*d1=ceil(*d1);
	return d1;
}
extern double* _stdcall PB_F64_Ceil2(double* d1, double* d2)
{
	*d2=ceil(*d1);
	return d2;
}
extern double* _stdcall PB_F64_Floor(double* d1)
{
	*d1=floor(*d1);
	return d1;
}
extern double* _stdcall PB_F64_Floor2(double* d1, double* d2)
{
	*d2=floor(*d1);
	return d2;
}
extern double* _stdcall PB_F64_Round(double* d1, int n)
{
	int p=abs(n);
	double e;
	char result[25];
	char format[]="                         ";
	if (p>16)
		p=16;
	e=1.0/pow(10,p+1);
	if (*d1<0)
		*d1-=e;
	else
		*d1+=e;
	sprintf(format,"%s%s%d%s","%"," .", p  ,"f");
	sprintf(result, format, *d1);
	*d1 = atof(result);
	return d1;
}
extern double* _stdcall PB_F64_Round2(double* d1, int n, double* d2)
{
	int p=abs(n);
	double e;
	char result[25];
	char format[]="                         ";
	if (p>16)
		p=16;
	e=1.0/pow(10,p+1);
	if (*d1<0)
		*d2=*d1-e;
	else
		*d2=*d1+e;
	sprintf(format,"%s%s%d%s","%"," .", p  ,"f");
	sprintf(result, format, *d2);
	*d2 = atof(result);
	return d2;
}
extern double* _stdcall PB_F64_SetInfinity(double* d1)
{
	double n=1;
	if (*d1<0.0)
	  n=-1;
	*d1=n/0.0;
	return d1;
}
extern double* _stdcall PB_F64_SetInfinity2(double* d1,int d2)
{
	double n=1;
	if (d2<0)
	  n=-1;
	*d1=n/0.0;
	return d1;
}
extern int _stdcall PB_F64_Sign(double* d1)
{
	if (*d1>0)
		return 1;
	else
	if (*d1==0)
		return 0;
	else
		return -1;
}
extern int _stdcall PB_F64_Sign2(double* d1, double* d2)
{
	if (*d1>0)
		{*d2=1;
		return 1;}
	else
	if (*d1==0)
		{*d2=0;
		return 0;}
	else
		{*d2=-1;
		return -1;}
}
extern double* _stdcall PB_F64_Abs(double* d)
{
  *d = fabs(*d);
  return d;
}
extern double* _stdcall PB_F64_Abs2(double* d, double* result)
{
  *result = fabs(*d);
  return result;
}
extern double* _stdcall PB_F64_Negate(double* d)
{
  *d = 0.0 - *d;
  return d;
}
extern double* _stdcall PB_F64_Negate2(double* d, double* result)
{
  *result = 0.0 - *d;
  return result;
}
extern double* _stdcall PB_F64_Inc(double* d)
{
  *d = *d + 1.0;
  return d;
}
extern double* _stdcall PB_F64_Add(double* d1, double* d2)
{
  *d1 = *d1 + *d2;
  return d1;
}
extern double* _stdcall PB_F64_Add2(double* d1, double* d2, double* result)
{
  *result = *d1 + *d2;
  return result;
}
extern double* _stdcall PB_F64_Dec(double* d)
{
  *d = *d - 1.0;
  return d;
}
extern double* _stdcall PB_F64_Sub(double* d1, double* d2)
{
  *d1 = *d1 - *d2;
  return d1;
}
extern double* _stdcall PB_F64_Sub2(double* d1, double* d2, double* result)
{
  *result = *d1 - *d2;
  return result;
}
extern double* _stdcall PB_F64_Mul(double* d1, double* d2)
{
  *d1 = *d1 * *d2;
  return d1;
}
extern double* _stdcall PB_F64_Mul2(double* d1, double* d2, double* result)
{
  *result = *d1 * *d2;
  return result;
}
extern double* _stdcall PB_F64_Div(double* d1, double* d2)
{
  *d1 = *d1 / *d2;
  return d1;
}
extern double* _stdcall PB_F64_Div2(double* d1, double* d2, double* result)
{
  *result = *d1 / *d2;
  return result;
}
extern double* _stdcall PB_F64_iDiv(double* d1, double* d2)
{
	double n;
	n=*d1/(*d2);
	if (n<0)
		*d1=0.0-floor(fabs(n));
	else
		*d1=floor(fabs(n));
	return d1;
}
extern double* _stdcall PB_F64_iDiv2(double* d1, double* d2, double* d3)
{
	*d3=*d1/(*d2);
	if (*d3<0)
		*d3=0.0-floor(fabs(*d3));
	else
		*d3=floor(fabs(*d3));
	return d3;
}
extern double* _stdcall PB_F64_Inv(double* d1)
{
	*d1=1.0/(*d1);
	return d1;
}
extern double* _stdcall PB_F64_Inv2(double* d1, double* d2)
{
	*d2=1.0/(*d1);
	return d2;
}
extern double* _stdcall PB_F64_Pow(double* d1, double* d2)
{
  *d1 = pow(*d1, *d2);
  return d1;
}

extern double* _stdcall PB_F64_Pow2(double* d1, double* d2, double* result)
{
  *result = pow(*d1, *d2);
  return result;
}
extern double* _stdcall PB_F64_Mod(double* d1, double* d2)
{
  *d1 = fmod(*d1, *d2);
  return d1;
}
extern double* _stdcall PB_F64_Mod2(double* d1, double* d2, double* result)
{
  *result = fmod(*d1, *d2);
  return result;
}
extern int _stdcall PB_F64_Gcd(double* d1,double* d2)
{
	int x=(int) *d1;
	int y=(int) *d2;
	int z;
	while (y!=0)
		{
			z=x%y;
			x=y;
			y=z;
		}
	return x;
}
extern int _stdcall PB_F64_Gcd2(double* d1,double* d2,double* d3)
{
	int x=(int) *d1;
	int y=(int) *d2;
	int z;
	while (y!=0)
		{
			z=x%y;
			x=y;
			y=z;
		}
	*d3=(double) x;
	return x;
}
extern int _stdcall PB_F64_Lcm(double* d1,double* d2)
{
	int x=(int) *d1;
	int y=(int) *d2;
	int z;
	int lcm=x*y;
	while (y!=0)
		{
			z=x%y;
			x=y;
			y=z;
		}
	return lcm/x;
}
extern int _stdcall PB_F64_Lcm2(double* d1,double* d2,double* d3)
{
	int x=(int) *d1;
	int y=(int) *d2;
	int z;
	int lcm=x*y;
	while (y!=0)
		{
			z=x%y;
			x=y;
			y=z;
		}
	x=lcm/x;
	*d3=(double) x;
	return x;
}
extern double* _stdcall PB_F64_Sqrt(double* d)
{
  *d = sqrt(*d);
  return d;
}
extern double* _stdcall PB_F64_Sqrt2(double* d, double* result)
{
  *result = sqrt(*d);
  return result;
}
extern double* _stdcall PB_F64_Cbrt(double* d1)
{
	*d1=pow(*d1, (double) 1/3);
	return d1;
}
extern double* _stdcall PB_F64_Cbrt2(double* d1, double* d2)
{
	*d2=pow(*d1, (double) 1/3);
	return d2;
}
extern double* _stdcall PB_F64_Sin(double* d)
{
  *d = sin(*d);
  return d;
}
extern double* _stdcall PB_F64_Sin2(double* d, double* result)
{
  *result = sin(*d);
  return result;
}
extern double* _stdcall PB_F64_Cos(double* d)
{
  *d = cos(*d);
  return d;
}
extern double* _stdcall PB_F64_Cos2(double* d, double* result)
{
  *result = cos(*d);
  return result;
}
extern double* _stdcall PB_F64_Tan(double* d)
{
  *d = tan(*d);
  return d;
}
extern double* _stdcall PB_F64_Tan2(double* d, double* result)
{
  *result = tan(*d);
  return result;
}
extern double* _stdcall PB_F64_Cot(double* d)
{
  *d = 1/tan(*d);
  return d;
}
extern double* _stdcall PB_F64_Cot2(double* d, double* result)
{
  *result = 1/tan(*d);
  return result;
}
extern double* _stdcall PB_F64_ASin(double* d)
{
  *d = asin(*d);
  return d;
}
extern double* _stdcall PB_F64_ASin2(double* d, double* result)
{
  *result = asin(*d);
  return result;
}
extern double* _stdcall PB_F64_ACos(double* d)
{
  *d = acos(*d);
  return d;
}
extern double* _stdcall PB_F64_ACos2(double* d, double* result)
{
  *result = acos(*d);
  return result;
}
extern double* _stdcall PB_F64_ATan(double* d)
{
  *d = atan(*d);
  return d;
}
extern double* _stdcall PB_F64_ATan2(double* d, double* result)
{
  *result = atan(*d);
  return result;
}
extern double* _stdcall PB_F64_AtanQuad(double* d1, double* d2)
{
	*d1=atan2(*d2,*d1);
	return d1;
}
extern double* _stdcall PB_F64_AtanQuad2(double* d1, double* d2, double* d3)
{
	*d3=atan2(*d2,*d1);
	return d3;
}
extern double* _stdcall PB_F64_SinH(double* d)
{
  *d = sinh(*d);
  return d;
}
extern double* _stdcall PB_F64_SinH2(double* d, double* result)
{
  *result = sinh(*d);
  return result;
}
extern double* _stdcall PB_F64_CosH(double* d)
{
  *d = cosh(*d);
  return d;
}
extern double* _stdcall PB_F64_CosH2(double* d, double* result)
{
  *result = cosh(*d);
  return result;
}
extern double* _stdcall PB_F64_TanH(double* d)
{
  *d = tanh(*d);
  return d;
}
extern double* _stdcall PB_F64_TanH2(double* d, double* result)
{
  *result = tanh(*d);
  return result;
}
extern double* _stdcall PB_F64_CotH(double* d)
{
  *d = (pow(M_E, 2**d)+1)/(pow(M_E, 2**d)-1);
  return d;
}
extern double* _stdcall PB_F64_CotH2(double* d, double* result)
{
  *result = (pow(M_E, 2**d)+1)/(pow(M_E, 2**d)-1);
  return result;
}
extern double* _stdcall PB_F64_ASinH(double* d)
{
  *d = log(*d + sqrt(*d**d+1));
  return d;
}
extern double* _stdcall PB_F64_ASinH2(double* d, double* result)
{
  *result = log(*d + sqrt(*d**d+1));
  return result;
}
extern double* _stdcall PB_F64_ACosH(double* d)
{
  double n=1;
  if((*d>=1) || (*d<=-1))
    *d = log(*d+sqrt(*d**d-1));
  else
    *d = n/0.0;
  return d;
}
extern double* _stdcall PB_F64_ACosH2(double* d, double* result)
{
  double n=1;
  if((*d>=1) || (*d<=-1))
    *result = log(*d+sqrt(*d**d-1));
  else
    *result = n/0.0;
  return result;
}
extern double* _stdcall PB_F64_ATanH(double* d)
{
  double n=1;
  if( (*d<1) && (*d>-1) )
    *d = 0.5 * log((1+*d)/(1-*d));
  else
    *d = n/0.0;
  return d;
}
extern double* _stdcall PB_F64_ATanH2(double* d, double* result)
{
  double n=1;
  if( (*d<1) && (*d>-1) )
    *result = 0.5 * log((1+*d)/(1-*d));
  else
    *result = n/0.0;
  return result;
}
extern double* _stdcall PB_F64_ACotH(double* d)
{
  double n=1;
  if( (*d>1) || (*d<-1))
    *d = 0.5*log((*d+1)/(*d-1));
  else
    *d = n/0.0;
  return d;
}
extern double* _stdcall PB_F64_ACotH2(double* d, double* result)
{
  double n=1;
  if( (*d>1) || (*d<-1))
    *result = 0.5*log((*d+1)/(*d-1));
  else
    *result = n/0;
  return result;
}
extern double* _stdcall PB_F64_LN(double* d)
{
  *d = log(*d);
  return d;
}
extern double* _stdcall PB_F64_LN2(double* d, double* result)
{
  *result = log(*d);
  return result;
}
extern double* _stdcall PB_F64_Log(double* d)
{
  *d = log10(*d);
  return d;
}
extern double* _stdcall PB_F64_Log2(double* d, double* result)
{
  *result = log10(*d);
  return result;
}
extern double* _stdcall PB_F64_Exp(double* d)
{
  *d = exp(*d);
  return d;
}
extern double* _stdcall PB_F64_Exp2(double* d, double* result)
{
  *result = exp(*d);
  return result;
}
extern double* _stdcall PB_F64_ExpTen(double* d)
{
  *d = exp(*d*M_LN10);
  return d;
}
extern double* _stdcall PB_F64_ExpTen2(double* d, double* result)
{
  *result = exp(*d*M_LN10);
  return result;
}
double gamma1(double xd)
{
    int i,k,m;
    double ga,gr,r,x,z;

    static double g[] = {
        1.0,
        0.5772156649015329,
       -0.6558780715202539,
       -0.4200263503409524e-1,
        0.1665386113822915,
       -0.421977345555443e-1,
       -0.9621971527876974e-2,
        0.72189432466631e-2,
       -0.1165167591859065e-2,
       -0.215241674114951e-3,
        0.1280502823881162e-3,
       -0.2013485478078824e-4,
       -0.1250493482142671e-5,
        0.1133027231981696e-5,
       -0.2056338416977607e-6,
        0.6116095104481416e-8,
        0.5002007644469223e-8,
       -0.1181274570487020e-8,
        0.1043426711691101e-9,
        0.7782263439905071e-11,
       -0.3696805618642206e-11,
        0.5100370287454476e-12,
       -0.2058326053566507e-13,
       -0.5348122539423018e-14,
        0.1226778628238261e-14};
    x=xd+1.0;
    if (x > 171.0) return 1e308;    /* This value is an overflow flag. */
    if (x == (int)x) {
        if (x > 0.0) {
            ga = 1.0;               /* use factorial */
            for (i=2;i<x;i++) {
               ga *= i;
            }
         }
         else
            ga = 1e308;
     }
     else {
        if (fabs(x) > 1.0) {
            z = fabs(x);
            m = (int)z;
            r = 1.0;
            for (k=1;k<=m;k++) {
                r *= (z-k);
            }
            z -= m;
        }
        else
            z = x;
        gr = g[24];
        for (k=23;k>=0;k--) {
            gr = gr*z+g[k];
        }
        ga = 1.0/(gr*z);
        if (fabs(x) > 1.0) {
            ga *= r;
            if (x < 0.0) {
                ga = -M_PI/(x*ga*sin(M_PI*x));
            }
        }
    }
    return ga;
}

extern double* _stdcall PB_F64_Factorial(double* d1)
{
	double i;
	i=fabs(*d1);
  	if ((*d1<0.0)&&((i-floor(i))==0))
		*d1=log(-1);				/* if d1 is negative integer return NAN */
	else
		*d1=gamma1(*d1);	 /* if d1 is not an integer return gamma(d1+1) */
	return d1;
}
extern double* _stdcall PB_F64_Factorial2(double* d1, double* d2)
{
	double i;
	i=fabs(*d1);
  	if ((*d1<0.0)&&((i-floor(i))==0))
		*d2=log(-1);/*if d1 is negative integer return NAN */
	else
		*d2=gamma1(*d1);	/* if d1 is not an integer return gamma(d1+1) */
	return d2;
}
double* random_aux(int n_args,double* d1,...)
{
	static int first_time=0;
	static __int64 shiftreg;/*=0x1954678542154787;*/
	__int64 mask=0x6fffffffffffffff;
	int temp;
	time_t t;
	va_list ap;
	va_start(ap,d1);
	if (n_args==2)
		{
		first_time=1;
		shiftreg=va_arg(ap, int);
		}
	else
	if (first_time==0)
		{
		first_time=1;				/*randomize if first call*/
		time(&t);
		shiftreg=t;
		}
	va_end(ap);
	_asm{
		movq mm0,shiftreg		/*get the last number */
		movq mm1,mm0			/*take a copy */
		psrlq mm1,1			/*do 1st tap bit (LSBs) */
		pxor mm0,mm1 
		psrlq mm1,2			/*do 2nd tap bit (LSBs) */
		pxor mm0,mm1 
		psrlq mm1,1 
		pxor mm0,mm1			/*do 3rd tap bit (LSBs), low 60 bits now done */
                					/*now correct for the high 4 bits */
		movq mm1,mm0    		/*take a copy */
		psllq mm1,60    			/*correct 3rd tap MSBs */
		pxor mm0,mm1 
		psllq mm1,1     			/*correct 2nd tap MSBs */
		pxor mm0,mm1 
		psllq mm1,2 
		pxor mm0,mm1    		/*correct 1st tap MSBs, all done */
		pxor mm0,mask
		movq shiftreg,mm0  		/*write back the result */
		emms          			/*re-enable FPU */
	}
              *d1=frexp((double) shiftreg,&temp);
	return d1;
}
extern double*  _stdcall PB_F64_Random(double* d1)
{	
	random_aux(1,d1);
	return d1;
}
extern double*  _stdcall PB_F64_Random2(double* d1,int d2)
{	
	random_aux(2,d1,d2);
	return d1;
}

#ifndef PURELIBRARY
void  _cdecl main(void)
  {
    char* PB_StringBase;
    PB_StringBase = "(c)2003 freedimension";
    double d = 6.0;
    double f = 4.01;
    PB_F64_Frac(&d);
    printf("%f", d);
  }
#endif
